polybori::groebner::PolyEntryVector Class Reference

`#include <PolyEntryVector.h>`

Inheritance diagram for polybori::groebner::PolyEntryVector:

## Public Member Functions

reference | first ()
| Alternative to `front` which allows partial (but consistent) access. More...
const_reference | first () const
| Constant variant, equivalent to `front`, for completeness reasons. More...
reference | last ()
| Alternative to `back()` which allows partial (but consistent) access. More...
const_reference | last () const
| Constant variant, equivalent to `back`, for completeness reasons. More...
| PolyEntryVector ()
| Default constructor. More...
virtual void | append (const PolyEntry &element)
| Just insert element. More...
template<class KeyType >
const_reference | operator() (const KeyType &key) const
| Read-only access to element by index, leading term or monomial. More...
template<class KeyType >
reference | operator() (const KeyType &rhs)
| (Partially) write access to element by index, leading term or monomial More...
template<class KeyType , class Type >
void | exchange (const KeyType &key, const Type &rhs)
| Exchange element given by `key`. More...
template<class KeyType >
size_type | index (const KeyType &key) const
| Retrieve index associated to `key`. More...
template<class KeyType >
size_type | checked_index (const KeyType &key) const
| Retrieve index associated to `key` if `key` exists, -1 otherwise. More...
template<class KeyType >
const Polynomial & | polynomial (const KeyType &key) const
| Retrieve polynomial associated to `key`. More...
typedef data_type::value_type | value_type
| Vector-style interface. More...
typedef data_type::size_type | size_type
typedef data_type::const_iterator | const_iterator
typedef data_type::const_reference | const_reference
typedef PolyEntryReference | reference
bool | empty () const
size_type | size () const
const_iterator | begin () const
const_iterator | end () const
const_reference | front () const
const_reference | back () const
template<class KeyType >
const_reference | operator[] (const KeyType &rhs) const
| Read-only access to element by index, leading term or monomial. More...

## Member Typedef Documentation

typedef data_type::const_iterator polybori::groebner::PolyEntryVector::const_iterator

typedef data_type::const_reference polybori::groebner::PolyEntryVector::const_reference

typedef PolyEntryReference polybori::groebner::PolyEntryVector::reference

typedef data_type::size_type polybori::groebner::PolyEntryVector::size_type

typedef data_type::value_type polybori::groebner::PolyEntryVector::value_type

Vector-style interface.

## Constructor & Destructor Documentation

polybori::groebner::PolyEntryVector::PolyEntryVector | ( |  | ) |

inline

Default constructor.

## Member Function Documentation

virtual void polybori::groebner::PolyEntryVector::append | ( | const PolyEntry & | element | ) |

inline virtual

Just insert element.

Reimplemented in polybori::groebner::ReductionStrategy.

const_reference polybori::groebner::PolyEntryVector::back | ( |  | ) | const

inline

const_iterator polybori::groebner::PolyEntryVector::begin | ( |  | ) | const

inline

Referenced by polybori::groebner::GroebnerStrategy::allGenerators(), and polybori::groebner::GroebnerStrategy::variableHasValue().

template<class KeyType >

size_type polybori::groebner::PolyEntryVector::checked_index | ( | const KeyType & | key | ) | const

inline

Retrieve index associated to `key` if `key` exists, -1 otherwise.

bool polybori::groebner::PolyEntryVector::empty | ( |  | ) | const

inline

Referenced by polybori::groebner::GroebnerStrategy::addGeneratorDelayed(), polybori::groebner::GroebnerStrategy::addGeneratorTrySplit(), and polybori::groebner::GroebnerStrategy::allGenerators().

const_iterator polybori::groebner::PolyEntryVector::end | ( |  | ) | const

inline

Referenced by polybori::groebner::GroebnerStrategy::allGenerators(), and polybori::groebner::GroebnerStrategy::variableHasValue().

template<class KeyType , class Type >

void polybori::groebner::PolyEntryVector::exchange | ( | const KeyType & | key,
|  | const Type & | rhs
| ) |  |

inline

Exchange element given by `key`.

reference polybori::groebner::PolyEntryVector::first | ( |  | ) |

inline

Alternative to `front` which allows partial (but consistent) access.

const_reference polybori::groebner::PolyEntryVector::first | ( |  | ) | const

inline

Constant variant, equivalent to `front`, for completeness reasons.

const_reference polybori::groebner::PolyEntryVector::front | ( |  | ) | const

inline

Referenced by polybori::groebner::GroebnerStrategy::allGenerators().

template<class KeyType >

size_type polybori::groebner::PolyEntryVector::index | ( | const KeyType & | key | ) | const

inline

Retrieve index associated to `key`.

Referenced by polybori::groebner::GroebnerStrategy::normalPairsWithLast(), polybori::groebner::ChainCriterion::operator()(), polybori::groebner::ChainVariableCriterion::operator()(), polybori::groebner::HasTRepOrExtendedProductCriterion::operator()(), polybori::groebner::CountCriterion::operator()(), polybori::groebner::select_largest_degree(), and polybori::groebner::select_no_deg_growth().

reference polybori::groebner::PolyEntryVector::last | ( |  | ) |

inline

Alternative to `back()` which allows partial (but consistent) access.

Referenced by polybori::groebner::GroebnerStrategy::addGenerator().

const_reference polybori::groebner::PolyEntryVector::last | ( |  | ) | const

inline

Constant variant, equivalent to `back`, for completeness reasons.

template<class KeyType >

const_reference polybori::groebner::PolyEntryVector::operator() | ( | const KeyType & | key | ) | const

inline

Read-only access to element by index, leading term or monomial.

template<class KeyType >

reference polybori::groebner::PolyEntryVector::operator() | ( | const KeyType & | rhs | ) |

inline

(Partially) write access to element by index, leading term or monomial

template<class KeyType >

const_reference polybori::groebner::PolyEntryVector::operator[] | ( | const KeyType & | rhs | ) | const

inline

Read-only access to element by index, leading term or monomial.

template<class KeyType >

const Polynomial& polybori::groebner::PolyEntryVector::polynomial | ( | const KeyType & | key | ) | const

inline

Retrieve polynomial associated to `key`.

size_type polybori::groebner::PolyEntryVector::size | ( |  | ) | const

inline

Referenced by polybori::groebner::GroebnerStrategy::addVariablePairs(), polybori::groebner::GroebnerStrategy::allGenerators(), polybori::groebner::FGLMStrategy::analyzeGB(), polybori::groebner::nf3(), polybori::groebner::nf3_degree_order(), polybori::groebner::nf3_lexbuckets(), polybori::groebner::nf3_no_deg_growth(), polybori::groebner::nf3_short(), and polybori::groebner::GroebnerStrategy::normalPairsWithLast().

The documentation for this class was generated from the following file:

- PolyEntryVector.h